using Microsoft.AspNetCore.Mvc;
using Robware.Api.Mailboxes.Models;
using Robware.Mailboxes;
using System.Linq;
using System.Threading.Tasks;

namespace Robware.Api.Mailboxes.Controllers {
	[ApiController]
	[Route("[controller]")]
	public class AliasController : ControllerBase {
		private readonly IAliases _aliases;

		public AliasController(IAliases aliases) {
			_aliases = aliases;
		}

		[HttpGet(nameof(List))]
		public async Task<ActionResult<Alias[]>> List() => (await _aliases.GetAll()).ToArray();

		[HttpPatch(nameof(Enable))]
		public async Task<ActionResult> Enable(int id) => (await _aliases.Enable(id)) ? NoContent() : BadRequest();

		[HttpPatch(nameof(Disable))]
		public async Task<ActionResult> Disable(int id) => (await _aliases.Disable(id)) ? NoContent() : BadRequest();

		[HttpPost(nameof(Create))]
		public async Task<ActionResult> Create(NewAlias alias) => (await _aliases.Create(alias.Source, alias.Destination, alias.Active) > 0) ? NoContent() : BadRequest();

		[HttpDelete(nameof(Delete))]
		public async Task<ActionResult> Delete(int id) => (await _aliases.Delete(id)) ? NoContent() : BadRequest();
	}
}